#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSFontFaceRule = 908,
  CSSFontFeatureValuesRule = 924,
  CSSFontPaletteValuesRule = 949,
  CSSGroupingRule = 974,
  CSSImportRule = 990,
  CSSKeyframeRule = 1004,
  CSSKeyframesRule = 1020,
  CSSLayerBlockRule = 1037,
  CSSLayerStatementRule = 1055,
  CSSMediaRule = 1077,
  CSSMozDocumentRule = 1090,
  CSSNamespaceRule = 1109,
  CSSPageRule = 1126,
  CSSPropertyRule = 1138,
  CSSPseudoElement = 1154,
  CSSRule = 1171,
  CSSRuleList = 1179,
  CSSStyleDeclaration = 1191,
  CSSStyleRule = 1211,
  CSSStyleSheet = 1224,
  CSSSupportsRule = 1238,
  CSSTransition = 1254,
  Cache = 1268,
  CacheStorage = 1274,
  CallbackDebuggerNotification = 1287,
  CanonicalBrowsingContext = 1316,
  CanvasCaptureMediaStream = 1341,
  CanvasGradient = 1366,
  CanvasPattern = 1381,
  CanvasRenderingContext2D = 1395,
  CaretPosition = 1420,
  CaretStateChangedEvent = 1434,
  ChannelMergerNode = 1457,
  ChannelSplitterNode = 1475,
  ChannelWrapper = 1495,
  CharacterData = 1510,
  CheckerboardReportService = 1524,
  ChildProcessMessageManager = 1550,
  ChildSHistory = 1577,
  ChromeMessageBroadcaster = 1591,
  ChromeMessageSender = 1616,
  ChromeNodeList = 1636,
  ChromeUtils = 1651,
  ChromeWorker = 1663,
  Client = 1676,
  Clients = 1683,
  Clipboard = 1691,
  ClipboardEvent = 1701,
  ClipboardItem = 1716,
  ClonedErrorHolder = 1730,
  CloseEvent = 1748,
  CommandEvent = 1759,
  Comment = 1772,
  CompositionEvent = 1780,
  CompressionStream = 1797,
  ConsoleInstance = 1815,
  ConstantSourceNode = 1831,
  ContentFrameMessageManager = 1850,
  ContentProcessMessageManager = 1877,
  ContentVisibilityAutoStateChangeEvent = 1906,
  ConvolverNode = 1944,
  CountQueuingStrategy = 1958,
  CreateOfferRequest = 1979,
  Credential = 1998,
  CredentialsContainer = 2009,
  Crypto = 2030,
  CryptoKey = 2037,
  CustomElementRegistry = 2047,
  CustomEvent = 2069,
  DOMException = 2081,
  DOMImplementation = 2094,
  DOMLocalization = 2112,
  DOMMatrix = 2128,
  DOMMatrixReadOnly = 2138,
  DOMParser = 2156,
  DOMPoint = 2166,
  DOMPointReadOnly = 2175,
  DOMQuad = 2192,
  DOMRect = 2200,
  DOMRectList = 2208,
  DOMRectReadOnly = 2220,
  DOMRequest = 2236,
  DOMStringList = 2247,
  DOMStringMap = 2261,
  DOMTokenList = 2274,
  DataTransfer = 2287,
  DataTransferItem = 2300,
  DataTransferItemList = 2317,
  DebuggerNotification = 2338,
  DebuggerNotificationObserver = 2359,
  DecompressionStream = 2388,
  DedicatedWorkerGlobalScope = 2408,
  DelayNode = 2435,
  DeprecationReportBody = 2445,
  DeviceAcceleration = 2467,
  DeviceLightEvent = 2486,
  DeviceMotionEvent = 2503,
  DeviceOrientationEvent = 2521,
  DeviceRotationRate = 2544,
  Directory = 2563,
  Document = 2573,
  DocumentFragment = 2582,
  DocumentL10n = 2599,
  DocumentTimeline = 2612,
  DocumentType = 2629,
  DominatorTree = 2642,
  DragEvent = 2656,
  DynamicsCompressorNode = 2666,
  EXT_blend_minmax = 2689,
  EXT_color_buffer_float = 2706,
  EXT_color_buffer_half_float = 2729,
  EXT_disjoint_timer_query = 2757,
  EXT_float_blend = 2782,
  EXT_frag_depth = 2798,
  EXT_sRGB = 2813,
  EXT_shader_texture_lod = 2822,
  EXT_texture_compression_bptc = 2845,
  EXT_texture_compression_rgtc = 2874,
  EXT_texture_filter_anisotropic = 2903,
  EXT_texture_norm16 = 2934,
  Element = 2953,
  ElementInternals = 2961,
  ErrorEvent = 2978,
  Event = 2989,
  EventCallbackDebuggerNotification = 2995,
  EventCounts = 3029,
  EventSource = 3041,
  EventTarget = 3053,
  Exception = 3065,
  ExtendableEvent = 3075,
  ExtendableMessageEvent = 3091,
  ExtensionAlarms = 3114,
  ExtensionBrowser = 3130,
  ExtensionBrowserSettings = 3147,
  ExtensionBrowserSettingsColorManagement = 3172,
  ExtensionDns = 3212,
  ExtensionEventManager = 3225,
  ExtensionMockAPI = 3247,
  ExtensionPort = 3264,
  ExtensionProxy = 3278,
  ExtensionRuntime = 3293,
  ExtensionScripting = 3310,
  ExtensionSetting = 3329,
  ExtensionTest = 3346,
  External = 3360,
  FeaturePolicy = 3369,
  FeaturePolicyViolationReportBody = 3383,
  FetchEvent = 3416,
  FetchObserver = 3427,
  File = 3441,
  FileList = 3446,
  FileReader = 3455,
  FileReaderSync = 3466,
  FileSystem = 3481,
  FileSystemDirectoryEntry = 3492,
  FileSystemDirectoryHandle = 3517,
  FileSystemDirectoryHandle_AsyncIterator = 3543,
  FileSystemDirectoryIterator = 3583,
  FileSystemDirectoryReader = 3611,
  FileSystemEntry = 3637,
  FileSystemFileEntry = 3653,
  FileSystemFileHandle = 3673,
  FileSystemHandle = 3694,
  FileSystemSyncAccessHandle = 3711,
  FileSystemWritableFileStream = 3738,
  Flex = 3767,
  FlexItemValues = 3772,
  FlexLineValues = 3787,
  FluentBundle = 3802,
  FluentBundleAsyncIterator = 3815,
  FluentBundleIterator = 3841,
  FluentPattern = 3862,
  FluentResource = 3876,
  FocusEvent = 3891,
  FontFace = 3902,
  FontFaceSet = 3911,
  FontFaceSetIterator = 3923,
  FontFaceSetLoadEvent = 3943,
  FormData = 3964,
  FormData_Iterator = 3973,
  FormDataEvent = 3991,
  FrameCrashedEvent = 4005,
  FrameLoader = 4023,
  GPU = 4035,
  GPUAdapter = 4039,
  GPUAdapterInfo = 4050,
  GPUBindGroup = 4065,
  GPUBindGroupLayout = 4078,
  GPUBuffer = 4097,
  GPUBufferUsage = 4107,
  GPUCanvasContext = 4122,
  GPUColorWrite = 4139,
  GPUCommandBuffer = 4153,
  GPUCommandEncoder = 4170,
  GPUCompilationInfo = 4188,
  GPUCompilationMessage = 4207,
  GPUComputePassEncoder = 4229,
  GPUComputePipeline = 4251,
  GPUDevice = 4270,
  GPUDeviceLostInfo = 4280,
  GPUMapMode = 4298,
  GPUOutOfMemoryError = 4309,
  GPUPipelineLayout = 4329,
  GPUQuerySet = 4347,
  GPUQueue = 4359,
  GPURenderBundle = 4368,
  GPURenderBundleEncoder = 4384,
  GPURenderPassEncoder = 4407,
  GPURenderPipeline = 4428,
  GPUSampler = 4446,
  GPUShaderModule = 4457,
  GPUShaderStage = 4473,
  GPUSupportedFeatures = 4488,
  GPUSupportedLimits = 4509,
  GPUTexture = 4528,
  GPUTextureUsage = 4539,
  GPUTextureView = 4555,
  GPUUncapturedErrorEvent = 4570,
  GPUValidationError = 4594,
  GainNode = 4613,
  Gamepad = 4622,
  GamepadAxisMoveEvent = 4630,
  GamepadButton = 4651,
  GamepadButtonEvent = 4665,
  GamepadEvent = 4684,
  GamepadHapticActuator = 4697,
  GamepadLightIndicator = 4719,
  GamepadPose = 4741,
  GamepadServiceTest = 4753,
  GamepadTouch = 4772,
  Geolocation = 4785,
  GeolocationCoordinates = 4797,
  GeolocationPosition = 4820,
  GeolocationPositionError = 4840,
  GetUserMediaRequest = 4865,
  GleanCategory = 4885,
  GleanImpl = 4899,
  GleanLabeled = 4909,
  GleanPingsImpl = 4922,
  Grid = 4937,
  GridArea = 4942,
  GridDimension = 4951,
  GridLine = 4965,
  GridLines = 4974,
  GridTrack = 4984,
  GridTracks = 4994,
  HTMLAllCollection = 5005,
  HTMLAnchorElement = 5023,
  HTMLAreaElement = 5041,
  HTMLAudioElement = 5057,
  HTMLBRElement = 5074,
  HTMLBaseElement = 5088,
  HTMLBodyElement = 5104,
  HTMLButtonElement = 5120,
  HTMLCanvasElement = 5138,
  HTMLCollection = 5156,
  HTMLDListElement = 5171,
  HTMLDataElement = 5188,
  HTMLDataListElement = 5204,
  HTMLDetailsElement = 5224,
  HTMLDialogElement = 5243,
  HTMLDirectoryElement = 5261,
  HTMLDivElement = 5282,
  HTMLDocument = 5297,
  HTMLElement = 5310,
  HTMLEmbedElement = 5322,
  HTMLFieldSetElement = 5339,
  HTMLFontElement = 5359,
  HTMLFormControlsCollection = 5375,
  HTMLFormElement = 5402,
  HTMLFrameElement = 5418,
  HTMLFrameSetElement = 5435,
  HTMLHRElement = 5455,
  HTMLHeadElement = 5469,
  HTMLHeadingElement = 5485,
  HTMLHtmlElement = 5504,
  HTMLIFrameElement = 5520,
  HTMLImageElement = 5538,
  HTMLInputElement = 5555,
  HTMLLIElement = 5572,
  HTMLLabelElement = 5586,
  HTMLLegendElement = 5603,
  HTMLLinkElement = 5621,
  HTMLMapElement = 5637,
  HTMLMarqueeElement = 5652,
  HTMLMediaElement = 5671,
  HTMLMenuElement = 5688,
  HTMLMetaElement = 5704,
  HTMLMeterElement = 5720,
  HTMLModElement = 5737,
  HTMLOListElement = 5752,
  HTMLObjectElement = 5769,
  HTMLOptGroupElement = 5787,
  HTMLOptionElement = 5807,
  HTMLOptionsCollection = 5825,
  HTMLOutputElement = 5847,
  HTMLParagraphElement = 5865,
  HTMLParamElement = 5886,
  HTMLPictureElement = 5903,
  HTMLPreElement = 5922,
  HTMLProgressElement = 5937,
  HTMLQuoteElement = 5957,
  HTMLScriptElement = 5974,
  HTMLSelectElement = 5992,
  HTMLSlotElement = 6010,
  HTMLSourceElement = 6026,
  HTMLSpanElement = 6044,
  HTMLStyleElement = 6060,
  HTMLTableCaptionElement = 6077,
  HTMLTableCellElement = 6101,
  HTMLTableColElement = 6122,
  HTMLTableElement = 6142,
  HTMLTableRowElement = 6159,
  HTMLTableSectionElement = 6179,
  HTMLTemplateElement = 6203,
  HTMLTextAreaElement = 6223,
  HTMLTimeElement = 6243,
  HTMLTitleElement = 6259,
  HTMLTrackElement = 6276,
  HTMLUListElement = 6293,
  HTMLUnknownElement = 6310,
  HTMLVideoElement = 6329,
  HashChangeEvent = 6346,
  Headers = 6362,
  Headers_Iterator = 6370,
  HeapSnapshot = 6387,
  Highlight = 6400,
  HighlightRegistry = 6410,
  History = 6428,
  IDBCursor = 6436,
  IDBCursorWithValue = 6446,
  IDBDatabase = 6465,
  IDBFactory = 6477,
  IDBIndex = 6488,
  IDBKeyRange = 6497,
  IDBLocaleAwareKeyRange = 6509,
  IDBObjectStore = 6532,
  IDBOpenDBRequest = 6547,
  IDBRequest = 6564,
  IDBTransaction = 6575,
  IDBVersionChangeEvent = 6590,
  IIRFilterNode = 6612,
  IOUtils = 6626,
  IdentityCredential = 6634,
  IdleDeadline = 6653,
  Image = 6666,
  ImageBitmap = 6672,
  ImageBitmapRenderingContext = 6684,
  ImageCapture = 6712,
  ImageCaptureError = 6725,
  ImageCaptureErrorEvent = 6743,
  ImageData = 6766,
  ImageDocument = 6776,
  InputEvent = 6790,
  InspectorFontFace = 6801,
  InspectorUtils = 6819,
  InstallTriggerImpl = 6834,
  IntersectionObserver = 6853,
  IntersectionObserverEntry = 6874,
  IntlUtils = 6900,
  JSProcessActorChild = 6910,
  JSProcessActorParent = 6930,
  JSWindowActorChild = 6951,
  JSWindowActorParent = 6970,
  KeyEvent = 6990,
  KeyboardEvent = 6999,
  KeyframeEffect = 7013,
  L10nFileSource = 7028,
  L10nOverlays = 7043,
  L10nRegistry = 7056,
  LargestContentfulPaint = 7069,
  LegacyMozTCPSocket = 7092,
  Localization = 7111,
  Location = 7124,
  Lock = 7133,
  LockManager = 7138,
  MIDIAccess = 7150,
  MIDIConnectionEvent = 7161,
  MIDIInput = 7181,
  MIDIInputMap = 7191,
  MIDIMessageEvent = 7204,
  MIDIOutput = 7221,
  MIDIOutputMap = 7232,
  MIDIPort = 7246,
  MOZ_debug = 7255,
  MatchGlob = 7265,
  MatchPattern = 7275,
  MatchPatternSet = 7288,
  MathMLElement = 7304,
  MediaCapabilities = 7318,
  MediaCapabilitiesInfo = 7336,
  MediaControlService = 7358,
  MediaController = 7378,
  MediaDeviceInfo = 7394,
  MediaDevices = 7410,
  MediaElementAudioSourceNode = 7423,
  MediaEncryptedEvent = 7451,
  MediaError = 7471,
  MediaKeyError = 7482,
  MediaKeyMessageEvent = 7496,
  MediaKeySession = 7517,
  MediaKeyStatusMap = 7533,
  MediaKeyStatusMap_Iterator = 7551,
  MediaKeySystemAccess = 7578,
  MediaKeys = 7599,
  MediaList = 7609,
  MediaMetadata = 7619,
  MediaQueryList = 7633,
  MediaQueryListEvent = 7648,
  MediaRecorder = 7668,
  MediaRecorderErrorEvent = 7682,
  MediaSession = 7706,
  MediaSource = 7719,
  MediaStream = 7731,
  MediaStreamAudioDestinationNode = 7743,
  MediaStreamAudioSourceNode = 7775,
  MediaStreamError = 7802,
  MediaStreamEvent = 7819,
  MediaStreamTrack = 7836,
  MediaStreamTrackAudioSourceNode = 7853,
  MediaStreamTrackEvent = 7885,
  MerchantValidationEvent = 7907,
  MessageBroadcaster = 7931,
  MessageChannel = 7950,
  MessageEvent = 7965,
  MessageListenerManager = 7978,
  MessagePort = 8001,
  MessageSender = 8013,
  MimeType = 8027,
  MimeTypeArray = 8036,
  MouseEvent = 8050,
  MouseScrollEvent = 8061,
  MozCanvasPrintState = 8078,
  MozDocumentMatcher = 8098,
  MozDocumentObserver = 8117,
  MozQueryInterface = 8137,
  MozSharedMap = 8155,
  MozSharedMap_Iterator = 8168,
  MozSharedMapChangeEvent = 8190,
  MozStorageAsyncStatementParams = 8214,
  MozStorageStatementParams = 8245,
  MozStorageStatementRow = 8271,
  MozWritableSharedMap = 8294,
  MutationEvent = 8315,
  MutationObserver = 8329,
  MutationRecord = 8346,
  NamedNodeMap = 8361,
  NavigationPreloadManager = 8374,
  Navigator = 8399,
  NetworkInformation = 8409,
  Node = 8428,
  NodeFilter = 8433,
  NodeIterator = 8444,
  NodeList = 8457,
  Notification = 8466,
  NotificationEvent = 8479,
  NotifyPaintEvent = 8497,
  OES_draw_buffers_indexed = 8514,
  OES_element_index_uint = 8539,
  OES_fbo_render_mipmap = 8562,
  OES_standard_derivatives = 8584,
  OES_texture_float = 8609,
  OES_texture_float_linear = 8627,
  OES_texture_half_float = 8652,
  OES_texture_half_float_linear = 8675,
  OES_vertex_array_object = 8705,
  OVR_multiview2 = 8729,
  OfflineAudioCompletionEvent = 8744,
  OfflineAudioContext = 8772,
  OffscreenCanvas = 8792,
  OffscreenCanvasRenderingContext2D = 8808,
  OnlyForUseInConstructor = 8842,
  Option = 8866,
  OscillatorNode = 8873,
  PageTransitionEvent = 8888,
  PaintRequest = 8908,
  PaintRequestList = 8921,
  PaintWorkletGlobalScope = 8938,
  PannerNode = 8962,
  ParentProcessMessageManager = 8973,
  Path2D = 9001,
  PathUtils = 9008,
  PaymentAddress = 9018,
  PaymentMethodChangeEvent = 9033,
  PaymentRequest = 9058,
  PaymentRequestUpdateEvent = 9073,
  PaymentResponse = 9099,
  Performance = 9115,
  PerformanceEntry = 9127,
  PerformanceEntryEvent = 9144,
  PerformanceEventTiming = 9166,
  PerformanceMark = 9189,
  PerformanceMeasure = 9205,
  PerformanceNavigation = 9224,
  PerformanceNavigationTiming = 9246,
  PerformanceObserver = 9274,
  PerformanceObserverEntryList = 9294,
  PerformancePaintTiming = 9323,
  PerformanceResourceTiming = 9346,
  PerformanceServerTiming = 9372,
  PerformanceTiming = 9396,
  PeriodicWave = 9414,
  PermissionStatus = 9427,
  Permissions = 9444,
  PlacesBookmark = 9456,
  PlacesBookmarkAddition = 9471,
  PlacesBookmarkChanged = 9494,
  PlacesBookmarkGuid = 9516,
  PlacesBookmarkKeyword = 9535,
  PlacesBookmarkMoved = 9557,
  PlacesBookmarkRemoved = 9577,
  PlacesBookmarkTags = 9599,
  PlacesBookmarkTime = 9618,
  PlacesBookmarkTitle = 9637,
  PlacesBookmarkUrl = 9657,
  PlacesEvent = 9675,
  PlacesFavicon = 9687,
  PlacesHistoryCleared = 9701,
  PlacesObservers = 9722,
  PlacesPurgeCaches = 9738,
  PlacesRanking = 9756,
  PlacesVisit = 9770,
  PlacesVisitRemoved = 9782,
  PlacesVisitTitle = 9801,
  PlacesWeakCallbackWrapper = 9818,
  Plugin = 9844,
  PluginArray = 9851,
  PluginCrashedEvent = 9863,
  PointerEvent = 9882,
  PopStateEvent = 9895,
  PopupBlockedEvent = 9909,
  PopupPositionedEvent = 9927,
  PositionStateEvent = 9948,
  PrecompiledScript = 9967,
  ProcessMessageManager = 9985,
  ProcessingInstruction = 10007,
  ProgressEvent = 10029,
  PromiseDebugging = 10043,
  PromiseNativeHandler = 10060,
  PromiseRejectionEvent = 10081,
  PublicKeyCredential = 10103,
  PushEvent = 10123,
  PushManager = 10133,
  PushManagerImpl = 10145,
  PushMessageData = 10161,
  PushSubscription = 10177,
  PushSubscriptionOptions = 10194,
  RadioNodeList = 10218,
  Range = 10232,
  ReadableByteStreamController = 10238,
  ReadableStream = 10267,
  ReadableStream_AsyncIterator = 10282,
  ReadableStreamBYOBReader = 10311,
  ReadableStreamBYOBRequest = 10336,
  ReadableStreamDefaultController = 10362,
  ReadableStreamDefaultReader = 10394,
  Report = 10422,
  ReportBody = 10429,
  ReportingObserver = 10440,
  Request = 10458,
  ResizeObserver = 10466,
  ResizeObserverEntry = 10481,
  ResizeObserverSize = 10501,
  Response = 10520,
  SVGAElement = 10529,
  SVGAngle = 10541,
  SVGAnimateElement = 10550,
  SVGAnimateMotionElement = 10568,
  SVGAnimateTransformElement = 10592,
  SVGAnimatedAngle = 10619,
  SVGAnimatedBoolean = 10636,
  SVGAnimatedEnumeration = 10655,
  SVGAnimatedInteger = 10678,
  SVGAnimatedLength = 10697,
  SVGAnimatedLengthList = 10715,
  SVGAnimatedNumber = 10737,
  SVGAnimatedNumberList = 10755,
  SVGAnimatedPreserveAspectRatio = 10777,
  SVGAnimatedRect = 10808,
  SVGAnimatedString = 10824,
  SVGAnimatedTransformList = 10842,
  SVGAnimationElement = 10867,
  SVGCircleElement = 10887,
  SVGClipPathElement = 10904,
  SVGComponentTransferFunctionElement = 10923,
  SVGDefsElement = 10959,
  SVGDescElement = 10974,
  SVGElement = 10989,
  SVGEllipseElement = 11000,
  SVGFEBlendElement = 11018,
  SVGFEColorMatrixElement = 11036,
  SVGFEComponentTransferElement = 11060,
  SVGFECompositeElement = 11090,
  SVGFEConvolveMatrixElement = 11112,
  SVGFEDiffuseLightingElement = 11139,
  SVGFEDisplacementMapElement = 11167,
  SVGFEDistantLightElement = 11195,
  SVGFEDropShadowElement = 11220,
  SVGFEFloodElement = 11243,
  SVGFEFuncAElement = 11261,
  SVGFEFuncBElement = 11279,
  SVGFEFuncGElement = 11297,
  SVGFEFuncRElement = 11315,
  SVGFEGaussianBlurElement = 11333,
  SVGFEImageElement = 11358,
  SVGFEMergeElement = 11376,
  SVGFEMergeNodeElement = 11394,
  SVGFEMorphologyElement = 11416,
  SVGFEOffsetElement = 11439,
  SVGFEPointLightElement = 11458,
  SVGFESpecularLightingElement = 11481,
  SVGFESpotLightElement = 11510,
  SVGFETileElement = 11532,
  SVGFETurbulenceElement = 11549,
  SVGFilterElement = 11572,
  SVGForeignObjectElement = 11589,
  SVGGElement = 11613,
  SVGGeometryElement = 11625,
  SVGGradientElement = 11644,
  SVGGraphicsElement = 11663,
  SVGImageElement = 11682,
  SVGLength = 11698,
  SVGLengthList = 11708,
  SVGLineElement = 11722,
  SVGLinearGradientElement = 11737,
  SVGMPathElement = 11762,
  SVGMarkerElement = 11778,
  SVGMaskElement = 11795,
  SVGMatrix = 11810,
  SVGMetadataElement = 11820,
  SVGNumber = 11839,
  SVGNumberList = 11849,
  SVGPathElement = 11863,
  SVGPathSeg = 11878,
  SVGPathSegArcAbs = 11889,
  SVGPathSegArcRel = 11906,
  SVGPathSegClosePath = 11923,
  SVGPathSegCurvetoCubicAbs = 11943,
  SVGPathSegCurvetoCubicRel = 11969,
  SVGPathSegCurvetoCubicSmoothAbs = 11995,
  SVGPathSegCurvetoCubicSmoothRel = 12027,
  SVGPathSegCurvetoQuadraticAbs = 12059,
  SVGPathSegCurvetoQuadraticRel = 12089,
  SVGPathSegCurvetoQuadraticSmoothAbs = 12119,
  SVGPathSegCurvetoQuadraticSmoothRel = 12155,
  SVGPathSegLinetoAbs = 12191,
  SVGPathSegLinetoHorizontalAbs = 12211,
  SVGPathSegLinetoHorizontalRel = 12241,
  SVGPathSegLinetoRel = 12271,
  SVGPathSegLinetoVerticalAbs = 12291,
  SVGPathSegLinetoVerticalRel = 12319,
  SVGPathSegList = 12347,
  SVGPathSegMovetoAbs = 12362,
  SVGPathSegMovetoRel = 12382,
  SVGPatternElement = 12402,
  SVGPoint = 12420,
  SVGPointList = 12429,
  SVGPolygonElement = 12442,
  SVGPolylineElement = 12460,
  SVGPreserveAspectRatio = 12479,
  SVGRadialGradientElement = 12502,
  SVGRect = 12527,
  SVGRectElement = 12535,
  SVGSVGElement = 12550,
  SVGScriptElement = 12564,
  SVGSetElement = 12581,
  SVGStopElement = 12595,
  SVGStringList = 12610,
  SVGStyleElement = 12624,
  SVGSwitchElement = 12640,
  SVGSymbolElement = 12657,
  SVGTSpanElement = 12674,
  SVGTextContentElement = 12690,
  SVGTextElement = 12712,
  SVGTextPathElement = 12727,
  SVGTextPositioningElement = 12746,
  SVGTitleElement = 12772,
  SVGTransform = 12788,
  SVGTransformList = 12801,
  SVGUnitTypes = 12818,
  SVGUseElement = 12831,
  SVGViewElement = 12845,
  Sanitizer = 12860,
  Scheduler = 12870,
  Screen = 12880,
  ScreenLuminance = 12887,
  ScreenOrientation = 12903,
  ScriptProcessorNode = 12921,
  ScrollAreaEvent = 12941,
  ScrollViewChangeEvent = 12957,
  SecurityPolicyViolationEvent = 12979,
  Selection = 13008,
  ServiceWorker = 13018,
  ServiceWorkerContainer = 13032,
  ServiceWorkerGlobalScope = 13055,
  ServiceWorkerRegistration = 13080,
  SessionStoreFormData = 13106,
  SessionStoreScrollData = 13127,
  SessionStoreUtils = 13150,
  ShadowRealmGlobalScope = 13168,
  ShadowRoot = 13191,
  SharedWorker = 13202,
  SharedWorkerGlobalScope = 13215,
  SimpleGestureEvent = 13239,
  SourceBuffer = 13258,
  SourceBufferList = 13271,
  SpeechGrammar = 13288,
  SpeechGrammarList = 13302,
  SpeechRecognition = 13320,
  SpeechRecognitionAlternative = 13338,
  SpeechRecognitionError = 13367,
  SpeechRecognitionEvent = 13390,
  SpeechRecognitionResult = 13413,
  SpeechRecognitionResultList = 13437,
  SpeechSynthesis = 13465,
  SpeechSynthesisErrorEvent = 13481,
  SpeechSynthesisEvent = 13507,
  SpeechSynthesisUtterance = 13528,
  SpeechSynthesisVoice = 13553,
  StaticRange = 13574,
  StereoPannerNode = 13586,
  Storage = 13603,
  StorageEvent = 13611,
  StorageManager = 13624,
  StreamFilter = 13639,
  StreamFilterDataEvent = 13652,
  StructuredCloneHolder = 13674,
  StructuredCloneTester = 13696,
  StyleSheet = 13718,
  StyleSheetApplicableStateChangeEvent = 13729,
  StyleSheetList = 13766,
  SubmitEvent = 13781,
  SubtleCrypto = 13793,
  SyncMessageSender = 13806,
  SyncReadFile = 13824,
  TCPServerSocket = 13837,
  TCPServerSocketEvent = 13853,
  TCPSocket = 13874,
  TCPSocketErrorEvent = 13884,
  TCPSocketEvent = 13904,
  TaskController = 13919,
  TaskPriorityChangeEvent = 13934,
  TaskSignal = 13958,
  TelemetryStopwatch = 13969,
  TestAttributesOnTypes = 13988,
  TestCEReactionsInterface = 14010,
  TestCImplementedInterface = 14035,
  TestCImplementedInterface2 = 14061,
  TestChildInterface = 14088,
  TestConstructorForFuncInterface = 14107,
  TestConstructorForPrefInterface = 14139,
  TestConstructorForSCInterface = 14171,
  TestCppKeywordNamedMethodsInterface = 14201,
  TestDeprecatedInterface = 14237,
  TestExampleInterface = 14261,
  TestExampleProxyInterface = 14282,
  TestExampleThrowingConstructorInterface = 14308,
  TestExampleWorkerInterface = 14348,
  TestFuncConstructorForDifferentFuncInterface = 14375,
  TestFuncConstructorForInterface = 14420,
  TestHTMLConstructorInterface = 14452,
  TestIndexedAndNamedGetterAndSetterInterface = 14481,
  TestIndexedAndNamedGetterInterface = 14525,
  TestIndexedAndNamedSetterInterface = 14560,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 14595,
  TestIndexedGetterInterface = 14645,
  TestIndexedSetterInterface = 14672,
  TestInterface = 14699,
  TestInterfaceWithPromiseConstructorArg = 14713,
  TestJSImplInterface = 14752,
  TestJSImplInterface2 = 14772,
  TestJSImplInterface3 = 14793,
  TestJSImplInterface4 = 14814,
  TestJSImplInterface5 = 14835,
  TestJSImplInterface6 = 14856,
  TestJSImplNoInterfaceObject = 14877,
  TestNamedDeleterInterface = 14905,
  TestNamedDeleterWithRetvalInterface = 14931,
  TestNamedGetterInterface = 14967,
  TestNamedSetterInterface = 14992,
  TestNamespace = 15017,
  TestNonWrapperCacheInterface = 15031,
  TestParentInterface = 15060,
  TestPrefChromeOnlySCFuncConstructorForInterface = 15080,
  TestPrefConstructorForDifferentPrefInterface = 15128,
  TestPrefConstructorForInterface = 15173,
  TestProtoObjectHackedNamespace = 15205,
  TestRenamedInterface = 15236,
  TestRenamedNamespace = 15257,
  TestSCConstructorForInterface = 15278,
  TestSecureContextInterface = 15308,
  TestThrowingConstructorInterface = 15335,
  TestUtils = 15368,
  TestWorkerExposedInterface = 15378,
  TestingDeprecatedInterface = 15405,
  Text = 15432,
  TextClause = 15437,
  TextDecoder = 15448,
  TextDecoderStream = 15460,
  TextEncoder = 15478,
  TextEncoderStream = 15490,
  TextMetrics = 15508,
  TextTrack = 15520,
  TextTrackCue = 15530,
  TextTrackCueList = 15543,
  TextTrackList = 15560,
  TimeEvent = 15574,
  TimeRanges = 15584,
  ToggleEvent = 15595,
  Touch = 15607,
  TouchEvent = 15613,
  TouchList = 15624,
  TrackEvent = 15634,
  TransformStream = 15645,
  TransformStreamDefaultController = 15661,
  TransitionEvent = 15694,
  TreeColumn = 15710,
  TreeColumns = 15721,
  TreeContentView = 15733,
  TreeWalker = 15749,
  UDPMessageEvent = 15760,
  UDPSocket = 15776,
  UIEvent = 15786,
  URL = 15794,
  URLSearchParams = 15798,
  URLSearchParams_Iterator = 15814,
  UniFFIPointer = 15839,
  UniFFIScaffolding = 15853,
  UserInteraction = 15871,
  UserProximityEvent = 15887,
  VRDisplay = 15906,
  VRDisplayCapabilities = 15916,
  VRDisplayEvent = 15938,
  VREyeParameters = 15953,
  VRFieldOfView = 15969,
  VRFrameData = 15983,
  VRMockController = 15995,
  VRMockDisplay = 16012,
  VRPose = 16026,
  VRServiceTest = 16033,
  VRStageParameters = 16047,
  VTTCue = 16065,
  VTTRegion = 16072,
  ValidityState = 16082,
  VideoColorSpace = 16096,
  VideoFrame = 16112,
  VideoPlaybackQuality = 16123,
  VideoTrack = 16144,
  VideoTrackList = 16155,
  VisualViewport = 16170,
  WEBGL_color_buffer_float = 16185,
  WEBGL_compressed_texture_astc = 16210,
  WEBGL_compressed_texture_etc = 16240,
  WEBGL_compressed_texture_etc1 = 16269,
  WEBGL_compressed_texture_pvrtc = 16299,
  WEBGL_compressed_texture_s3tc = 16330,
  WEBGL_compressed_texture_s3tc_srgb = 16360,
  WEBGL_debug_renderer_info = 16395,
  WEBGL_debug_shaders = 16421,
  WEBGL_depth_texture = 16441,
  WEBGL_draw_buffers = 16461,
  WEBGL_explicit_present = 16480,
  WEBGL_lose_context = 16503,
  WEBGL_provoking_vertex = 16522,
  WaveShaperNode = 16545,
  WebExtensionContentScript = 16560,
  WebExtensionPolicy = 16586,
  WebGL2RenderingContext = 16605,
  WebGLActiveInfo = 16628,
  WebGLBuffer = 16644,
  WebGLContextEvent = 16656,
  WebGLFramebuffer = 16674,
  WebGLProgram = 16691,
  WebGLQuery = 16704,
  WebGLRenderbuffer = 16715,
  WebGLRenderingContext = 16733,
  WebGLSampler = 16755,
  WebGLShader = 16768,
  WebGLShaderPrecisionFormat = 16780,
  WebGLSync = 16807,
  WebGLTexture = 16817,
  WebGLTransformFeedback = 16830,
  WebGLUniformLocation = 16853,
  WebGLVertexArrayObject = 16874,
  WebKitCSSMatrix = 16897,
  WebSocket = 16913,
  WebTransport = 16923,
  WebTransportBidirectionalStream = 16936,
  WebTransportDatagramDuplexStream = 16968,
  WebTransportError = 17001,
  WebTransportReceiveStream = 17019,
  WebTransportSendStream = 17045,
  WheelEvent = 17068,
  Window = 17079,
  WindowClient = 17086,
  WindowContext = 17099,
  WindowGlobalChild = 17113,
  WindowGlobalParent = 17131,
  WindowRoot = 17150,
  Worker = 17161,
  WorkerDebuggerGlobalScope = 17168,
  WorkerGlobalScope = 17194,
  WorkerLocation = 17212,
  WorkerNavigator = 17227,
  WorkerTestUtils = 17243,
  Worklet = 17259,
  WorkletGlobalScope = 17267,
  WritableStream = 17286,
  WritableStreamDefaultController = 17301,
  WritableStreamDefaultWriter = 17333,
  XMLDocument = 17361,
  XMLHttpRequest = 17373,
  XMLHttpRequestEventTarget = 17388,
  XMLHttpRequestUpload = 17414,
  XMLSerializer = 17435,
  XPathEvaluator = 17449,
  XPathExpression = 17464,
  XPathResult = 17480,
  XRBoundedReferenceSpace = 17492,
  XRFrame = 17516,
  XRInputSource = 17524,
  XRInputSourceArray = 17538,
  XRInputSourceEvent = 17557,
  XRInputSourcesChangeEvent = 17576,
  XRPose = 17602,
  XRReferenceSpace = 17609,
  XRReferenceSpaceEvent = 17626,
  XRRenderState = 17648,
  XRRigidTransform = 17662,
  XRSession = 17679,
  XRSessionEvent = 17689,
  XRSpace = 17704,
  XRSystem = 17712,
  XRView = 17721,
  XRViewerPose = 17728,
  XRViewport = 17741,
  XRWebGLLayer = 17752,
  XSLTProcessor = 17765,
  XULCommandEvent = 17779,
  XULElement = 17795,
  XULFrameElement = 17806,
  XULMenuElement = 17822,
  XULPopupElement = 17837,
  XULResizerElement = 17853,
  XULTextElement = 17871,
  XULTreeElement = 17886,
  console = 17901,
  webkitSpeechGrammar = 17909,
  webkitSpeechGrammarList = 17929,
  webkitSpeechRecognition = 17953,
  webkitURL = 17977,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
