#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSContainerRule" "\0"
  /*   888 */ "CSSCounterStyleRule" "\0"
  /*   908 */ "CSSFontFaceRule" "\0"
  /*   924 */ "CSSFontFeatureValuesRule" "\0"
  /*   949 */ "CSSFontPaletteValuesRule" "\0"
  /*   974 */ "CSSGroupingRule" "\0"
  /*   990 */ "CSSImportRule" "\0"
  /*  1004 */ "CSSKeyframeRule" "\0"
  /*  1020 */ "CSSKeyframesRule" "\0"
  /*  1037 */ "CSSLayerBlockRule" "\0"
  /*  1055 */ "CSSLayerStatementRule" "\0"
  /*  1077 */ "CSSMediaRule" "\0"
  /*  1090 */ "CSSMozDocumentRule" "\0"
  /*  1109 */ "CSSNamespaceRule" "\0"
  /*  1126 */ "CSSPageRule" "\0"
  /*  1138 */ "CSSPropertyRule" "\0"
  /*  1154 */ "CSSPseudoElement" "\0"
  /*  1171 */ "CSSRule" "\0"
  /*  1179 */ "CSSRuleList" "\0"
  /*  1191 */ "CSSStyleDeclaration" "\0"
  /*  1211 */ "CSSStyleRule" "\0"
  /*  1224 */ "CSSStyleSheet" "\0"
  /*  1238 */ "CSSSupportsRule" "\0"
  /*  1254 */ "CSSTransition" "\0"
  /*  1268 */ "Cache" "\0"
  /*  1274 */ "CacheStorage" "\0"
  /*  1287 */ "CallbackDebuggerNotification" "\0"
  /*  1316 */ "CanonicalBrowsingContext" "\0"
  /*  1341 */ "CanvasCaptureMediaStream" "\0"
  /*  1366 */ "CanvasGradient" "\0"
  /*  1381 */ "CanvasPattern" "\0"
  /*  1395 */ "CanvasRenderingContext2D" "\0"
  /*  1420 */ "CaretPosition" "\0"
  /*  1434 */ "CaretStateChangedEvent" "\0"
  /*  1457 */ "ChannelMergerNode" "\0"
  /*  1475 */ "ChannelSplitterNode" "\0"
  /*  1495 */ "ChannelWrapper" "\0"
  /*  1510 */ "CharacterData" "\0"
  /*  1524 */ "CheckerboardReportService" "\0"
  /*  1550 */ "ChildProcessMessageManager" "\0"
  /*  1577 */ "ChildSHistory" "\0"
  /*  1591 */ "ChromeMessageBroadcaster" "\0"
  /*  1616 */ "ChromeMessageSender" "\0"
  /*  1636 */ "ChromeNodeList" "\0"
  /*  1651 */ "ChromeUtils" "\0"
  /*  1663 */ "ChromeWorker" "\0"
  /*  1676 */ "Client" "\0"
  /*  1683 */ "Clients" "\0"
  /*  1691 */ "Clipboard" "\0"
  /*  1701 */ "ClipboardEvent" "\0"
  /*  1716 */ "ClipboardItem" "\0"
  /*  1730 */ "ClonedErrorHolder" "\0"
  /*  1748 */ "CloseEvent" "\0"
  /*  1759 */ "CommandEvent" "\0"
  /*  1772 */ "Comment" "\0"
  /*  1780 */ "CompositionEvent" "\0"
  /*  1797 */ "CompressionStream" "\0"
  /*  1815 */ "ConsoleInstance" "\0"
  /*  1831 */ "ConstantSourceNode" "\0"
  /*  1850 */ "ContentFrameMessageManager" "\0"
  /*  1877 */ "ContentProcessMessageManager" "\0"
  /*  1906 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  1944 */ "ConvolverNode" "\0"
  /*  1958 */ "CountQueuingStrategy" "\0"
  /*  1979 */ "CreateOfferRequest" "\0"
  /*  1998 */ "Credential" "\0"
  /*  2009 */ "CredentialsContainer" "\0"
  /*  2030 */ "Crypto" "\0"
  /*  2037 */ "CryptoKey" "\0"
  /*  2047 */ "CustomElementRegistry" "\0"
  /*  2069 */ "CustomEvent" "\0"
  /*  2081 */ "DOMException" "\0"
  /*  2094 */ "DOMImplementation" "\0"
  /*  2112 */ "DOMLocalization" "\0"
  /*  2128 */ "DOMMatrix" "\0"
  /*  2138 */ "DOMMatrixReadOnly" "\0"
  /*  2156 */ "DOMParser" "\0"
  /*  2166 */ "DOMPoint" "\0"
  /*  2175 */ "DOMPointReadOnly" "\0"
  /*  2192 */ "DOMQuad" "\0"
  /*  2200 */ "DOMRect" "\0"
  /*  2208 */ "DOMRectList" "\0"
  /*  2220 */ "DOMRectReadOnly" "\0"
  /*  2236 */ "DOMRequest" "\0"
  /*  2247 */ "DOMStringList" "\0"
  /*  2261 */ "DOMStringMap" "\0"
  /*  2274 */ "DOMTokenList" "\0"
  /*  2287 */ "DataTransfer" "\0"
  /*  2300 */ "DataTransferItem" "\0"
  /*  2317 */ "DataTransferItemList" "\0"
  /*  2338 */ "DebuggerNotification" "\0"
  /*  2359 */ "DebuggerNotificationObserver" "\0"
  /*  2388 */ "DecompressionStream" "\0"
  /*  2408 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2435 */ "DelayNode" "\0"
  /*  2445 */ "DeprecationReportBody" "\0"
  /*  2467 */ "DeviceAcceleration" "\0"
  /*  2486 */ "DeviceLightEvent" "\0"
  /*  2503 */ "DeviceMotionEvent" "\0"
  /*  2521 */ "DeviceOrientationEvent" "\0"
  /*  2544 */ "DeviceRotationRate" "\0"
  /*  2563 */ "Directory" "\0"
  /*  2573 */ "Document" "\0"
  /*  2582 */ "DocumentFragment" "\0"
  /*  2599 */ "DocumentL10n" "\0"
  /*  2612 */ "DocumentTimeline" "\0"
  /*  2629 */ "DocumentType" "\0"
  /*  2642 */ "DominatorTree" "\0"
  /*  2656 */ "DragEvent" "\0"
  /*  2666 */ "DynamicsCompressorNode" "\0"
  /*  2689 */ "EXT_blend_minmax" "\0"
  /*  2706 */ "EXT_color_buffer_float" "\0"
  /*  2729 */ "EXT_color_buffer_half_float" "\0"
  /*  2757 */ "EXT_disjoint_timer_query" "\0"
  /*  2782 */ "EXT_float_blend" "\0"
  /*  2798 */ "EXT_frag_depth" "\0"
  /*  2813 */ "EXT_sRGB" "\0"
  /*  2822 */ "EXT_shader_texture_lod" "\0"
  /*  2845 */ "EXT_texture_compression_bptc" "\0"
  /*  2874 */ "EXT_texture_compression_rgtc" "\0"
  /*  2903 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2934 */ "EXT_texture_norm16" "\0"
  /*  2953 */ "Element" "\0"
  /*  2961 */ "ElementInternals" "\0"
  /*  2978 */ "ErrorEvent" "\0"
  /*  2989 */ "Event" "\0"
  /*  2995 */ "EventCallbackDebuggerNotification" "\0"
  /*  3029 */ "EventCounts" "\0"
  /*  3041 */ "EventSource" "\0"
  /*  3053 */ "EventTarget" "\0"
  /*  3065 */ "Exception" "\0"
  /*  3075 */ "ExtendableEvent" "\0"
  /*  3091 */ "ExtendableMessageEvent" "\0"
  /*  3114 */ "ExtensionAlarms" "\0"
  /*  3130 */ "ExtensionBrowser" "\0"
  /*  3147 */ "ExtensionBrowserSettings" "\0"
  /*  3172 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3212 */ "ExtensionDns" "\0"
  /*  3225 */ "ExtensionEventManager" "\0"
  /*  3247 */ "ExtensionMockAPI" "\0"
  /*  3264 */ "ExtensionPort" "\0"
  /*  3278 */ "ExtensionProxy" "\0"
  /*  3293 */ "ExtensionRuntime" "\0"
  /*  3310 */ "ExtensionScripting" "\0"
  /*  3329 */ "ExtensionSetting" "\0"
  /*  3346 */ "ExtensionTest" "\0"
  /*  3360 */ "External" "\0"
  /*  3369 */ "FeaturePolicy" "\0"
  /*  3383 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3416 */ "FetchEvent" "\0"
  /*  3427 */ "FetchObserver" "\0"
  /*  3441 */ "File" "\0"
  /*  3446 */ "FileList" "\0"
  /*  3455 */ "FileReader" "\0"
  /*  3466 */ "FileReaderSync" "\0"
  /*  3481 */ "FileSystem" "\0"
  /*  3492 */ "FileSystemDirectoryEntry" "\0"
  /*  3517 */ "FileSystemDirectoryHandle" "\0"
  /*  3543 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3583 */ "FileSystemDirectoryIterator" "\0"
  /*  3611 */ "FileSystemDirectoryReader" "\0"
  /*  3637 */ "FileSystemEntry" "\0"
  /*  3653 */ "FileSystemFileEntry" "\0"
  /*  3673 */ "FileSystemFileHandle" "\0"
  /*  3694 */ "FileSystemHandle" "\0"
  /*  3711 */ "FileSystemSyncAccessHandle" "\0"
  /*  3738 */ "FileSystemWritableFileStream" "\0"
  /*  3767 */ "Flex" "\0"
  /*  3772 */ "FlexItemValues" "\0"
  /*  3787 */ "FlexLineValues" "\0"
  /*  3802 */ "FluentBundle" "\0"
  /*  3815 */ "FluentBundleAsyncIterator" "\0"
  /*  3841 */ "FluentBundleIterator" "\0"
  /*  3862 */ "FluentPattern" "\0"
  /*  3876 */ "FluentResource" "\0"
  /*  3891 */ "FocusEvent" "\0"
  /*  3902 */ "FontFace" "\0"
  /*  3911 */ "FontFaceSet" "\0"
  /*  3923 */ "FontFaceSetIterator" "\0"
  /*  3943 */ "FontFaceSetLoadEvent" "\0"
  /*  3964 */ "FormData" "\0"
  /*  3973 */ "FormData Iterator" "\0"
  /*  3991 */ "FormDataEvent" "\0"
  /*  4005 */ "FrameCrashedEvent" "\0"
  /*  4023 */ "FrameLoader" "\0"
  /*  4035 */ "GPU" "\0"
  /*  4039 */ "GPUAdapter" "\0"
  /*  4050 */ "GPUAdapterInfo" "\0"
  /*  4065 */ "GPUBindGroup" "\0"
  /*  4078 */ "GPUBindGroupLayout" "\0"
  /*  4097 */ "GPUBuffer" "\0"
  /*  4107 */ "GPUBufferUsage" "\0"
  /*  4122 */ "GPUCanvasContext" "\0"
  /*  4139 */ "GPUColorWrite" "\0"
  /*  4153 */ "GPUCommandBuffer" "\0"
  /*  4170 */ "GPUCommandEncoder" "\0"
  /*  4188 */ "GPUCompilationInfo" "\0"
  /*  4207 */ "GPUCompilationMessage" "\0"
  /*  4229 */ "GPUComputePassEncoder" "\0"
  /*  4251 */ "GPUComputePipeline" "\0"
  /*  4270 */ "GPUDevice" "\0"
  /*  4280 */ "GPUDeviceLostInfo" "\0"
  /*  4298 */ "GPUMapMode" "\0"
  /*  4309 */ "GPUOutOfMemoryError" "\0"
  /*  4329 */ "GPUPipelineLayout" "\0"
  /*  4347 */ "GPUQuerySet" "\0"
  /*  4359 */ "GPUQueue" "\0"
  /*  4368 */ "GPURenderBundle" "\0"
  /*  4384 */ "GPURenderBundleEncoder" "\0"
  /*  4407 */ "GPURenderPassEncoder" "\0"
  /*  4428 */ "GPURenderPipeline" "\0"
  /*  4446 */ "GPUSampler" "\0"
  /*  4457 */ "GPUShaderModule" "\0"
  /*  4473 */ "GPUShaderStage" "\0"
  /*  4488 */ "GPUSupportedFeatures" "\0"
  /*  4509 */ "GPUSupportedLimits" "\0"
  /*  4528 */ "GPUTexture" "\0"
  /*  4539 */ "GPUTextureUsage" "\0"
  /*  4555 */ "GPUTextureView" "\0"
  /*  4570 */ "GPUUncapturedErrorEvent" "\0"
  /*  4594 */ "GPUValidationError" "\0"
  /*  4613 */ "GainNode" "\0"
  /*  4622 */ "Gamepad" "\0"
  /*  4630 */ "GamepadAxisMoveEvent" "\0"
  /*  4651 */ "GamepadButton" "\0"
  /*  4665 */ "GamepadButtonEvent" "\0"
  /*  4684 */ "GamepadEvent" "\0"
  /*  4697 */ "GamepadHapticActuator" "\0"
  /*  4719 */ "GamepadLightIndicator" "\0"
  /*  4741 */ "GamepadPose" "\0"
  /*  4753 */ "GamepadServiceTest" "\0"
  /*  4772 */ "GamepadTouch" "\0"
  /*  4785 */ "Geolocation" "\0"
  /*  4797 */ "GeolocationCoordinates" "\0"
  /*  4820 */ "GeolocationPosition" "\0"
  /*  4840 */ "GeolocationPositionError" "\0"
  /*  4865 */ "GetUserMediaRequest" "\0"
  /*  4885 */ "GleanCategory" "\0"
  /*  4899 */ "GleanImpl" "\0"
  /*  4909 */ "GleanLabeled" "\0"
  /*  4922 */ "GleanPingsImpl" "\0"
  /*  4937 */ "Grid" "\0"
  /*  4942 */ "GridArea" "\0"
  /*  4951 */ "GridDimension" "\0"
  /*  4965 */ "GridLine" "\0"
  /*  4974 */ "GridLines" "\0"
  /*  4984 */ "GridTrack" "\0"
  /*  4994 */ "GridTracks" "\0"
  /*  5005 */ "HTMLAllCollection" "\0"
  /*  5023 */ "HTMLAnchorElement" "\0"
  /*  5041 */ "HTMLAreaElement" "\0"
  /*  5057 */ "HTMLAudioElement" "\0"
  /*  5074 */ "HTMLBRElement" "\0"
  /*  5088 */ "HTMLBaseElement" "\0"
  /*  5104 */ "HTMLBodyElement" "\0"
  /*  5120 */ "HTMLButtonElement" "\0"
  /*  5138 */ "HTMLCanvasElement" "\0"
  /*  5156 */ "HTMLCollection" "\0"
  /*  5171 */ "HTMLDListElement" "\0"
  /*  5188 */ "HTMLDataElement" "\0"
  /*  5204 */ "HTMLDataListElement" "\0"
  /*  5224 */ "HTMLDetailsElement" "\0"
  /*  5243 */ "HTMLDialogElement" "\0"
  /*  5261 */ "HTMLDirectoryElement" "\0"
  /*  5282 */ "HTMLDivElement" "\0"
  /*  5297 */ "HTMLDocument" "\0"
  /*  5310 */ "HTMLElement" "\0"
  /*  5322 */ "HTMLEmbedElement" "\0"
  /*  5339 */ "HTMLFieldSetElement" "\0"
  /*  5359 */ "HTMLFontElement" "\0"
  /*  5375 */ "HTMLFormControlsCollection" "\0"
  /*  5402 */ "HTMLFormElement" "\0"
  /*  5418 */ "HTMLFrameElement" "\0"
  /*  5435 */ "HTMLFrameSetElement" "\0"
  /*  5455 */ "HTMLHRElement" "\0"
  /*  5469 */ "HTMLHeadElement" "\0"
  /*  5485 */ "HTMLHeadingElement" "\0"
  /*  5504 */ "HTMLHtmlElement" "\0"
  /*  5520 */ "HTMLIFrameElement" "\0"
  /*  5538 */ "HTMLImageElement" "\0"
  /*  5555 */ "HTMLInputElement" "\0"
  /*  5572 */ "HTMLLIElement" "\0"
  /*  5586 */ "HTMLLabelElement" "\0"
  /*  5603 */ "HTMLLegendElement" "\0"
  /*  5621 */ "HTMLLinkElement" "\0"
  /*  5637 */ "HTMLMapElement" "\0"
  /*  5652 */ "HTMLMarqueeElement" "\0"
  /*  5671 */ "HTMLMediaElement" "\0"
  /*  5688 */ "HTMLMenuElement" "\0"
  /*  5704 */ "HTMLMetaElement" "\0"
  /*  5720 */ "HTMLMeterElement" "\0"
  /*  5737 */ "HTMLModElement" "\0"
  /*  5752 */ "HTMLOListElement" "\0"
  /*  5769 */ "HTMLObjectElement" "\0"
  /*  5787 */ "HTMLOptGroupElement" "\0"
  /*  5807 */ "HTMLOptionElement" "\0"
  /*  5825 */ "HTMLOptionsCollection" "\0"
  /*  5847 */ "HTMLOutputElement" "\0"
  /*  5865 */ "HTMLParagraphElement" "\0"
  /*  5886 */ "HTMLParamElement" "\0"
  /*  5903 */ "HTMLPictureElement" "\0"
  /*  5922 */ "HTMLPreElement" "\0"
  /*  5937 */ "HTMLProgressElement" "\0"
  /*  5957 */ "HTMLQuoteElement" "\0"
  /*  5974 */ "HTMLScriptElement" "\0"
  /*  5992 */ "HTMLSelectElement" "\0"
  /*  6010 */ "HTMLSlotElement" "\0"
  /*  6026 */ "HTMLSourceElement" "\0"
  /*  6044 */ "HTMLSpanElement" "\0"
  /*  6060 */ "HTMLStyleElement" "\0"
  /*  6077 */ "HTMLTableCaptionElement" "\0"
  /*  6101 */ "HTMLTableCellElement" "\0"
  /*  6122 */ "HTMLTableColElement" "\0"
  /*  6142 */ "HTMLTableElement" "\0"
  /*  6159 */ "HTMLTableRowElement" "\0"
  /*  6179 */ "HTMLTableSectionElement" "\0"
  /*  6203 */ "HTMLTemplateElement" "\0"
  /*  6223 */ "HTMLTextAreaElement" "\0"
  /*  6243 */ "HTMLTimeElement" "\0"
  /*  6259 */ "HTMLTitleElement" "\0"
  /*  6276 */ "HTMLTrackElement" "\0"
  /*  6293 */ "HTMLUListElement" "\0"
  /*  6310 */ "HTMLUnknownElement" "\0"
  /*  6329 */ "HTMLVideoElement" "\0"
  /*  6346 */ "HashChangeEvent" "\0"
  /*  6362 */ "Headers" "\0"
  /*  6370 */ "Headers Iterator" "\0"
  /*  6387 */ "HeapSnapshot" "\0"
  /*  6400 */ "Highlight" "\0"
  /*  6410 */ "HighlightRegistry" "\0"
  /*  6428 */ "History" "\0"
  /*  6436 */ "IDBCursor" "\0"
  /*  6446 */ "IDBCursorWithValue" "\0"
  /*  6465 */ "IDBDatabase" "\0"
  /*  6477 */ "IDBFactory" "\0"
  /*  6488 */ "IDBIndex" "\0"
  /*  6497 */ "IDBKeyRange" "\0"
  /*  6509 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6532 */ "IDBObjectStore" "\0"
  /*  6547 */ "IDBOpenDBRequest" "\0"
  /*  6564 */ "IDBRequest" "\0"
  /*  6575 */ "IDBTransaction" "\0"
  /*  6590 */ "IDBVersionChangeEvent" "\0"
  /*  6612 */ "IIRFilterNode" "\0"
  /*  6626 */ "IOUtils" "\0"
  /*  6634 */ "IdentityCredential" "\0"
  /*  6653 */ "IdleDeadline" "\0"
  /*  6666 */ "Image" "\0"
  /*  6672 */ "ImageBitmap" "\0"
  /*  6684 */ "ImageBitmapRenderingContext" "\0"
  /*  6712 */ "ImageCapture" "\0"
  /*  6725 */ "ImageCaptureError" "\0"
  /*  6743 */ "ImageCaptureErrorEvent" "\0"
  /*  6766 */ "ImageData" "\0"
  /*  6776 */ "ImageDocument" "\0"
  /*  6790 */ "InputEvent" "\0"
  /*  6801 */ "InspectorFontFace" "\0"
  /*  6819 */ "InspectorUtils" "\0"
  /*  6834 */ "InstallTriggerImpl" "\0"
  /*  6853 */ "IntersectionObserver" "\0"
  /*  6874 */ "IntersectionObserverEntry" "\0"
  /*  6900 */ "IntlUtils" "\0"
  /*  6910 */ "JSProcessActorChild" "\0"
  /*  6930 */ "JSProcessActorParent" "\0"
  /*  6951 */ "JSWindowActorChild" "\0"
  /*  6970 */ "JSWindowActorParent" "\0"
  /*  6990 */ "KeyEvent" "\0"
  /*  6999 */ "KeyboardEvent" "\0"
  /*  7013 */ "KeyframeEffect" "\0"
  /*  7028 */ "L10nFileSource" "\0"
  /*  7043 */ "L10nOverlays" "\0"
  /*  7056 */ "L10nRegistry" "\0"
  /*  7069 */ "LargestContentfulPaint" "\0"
  /*  7092 */ "LegacyMozTCPSocket" "\0"
  /*  7111 */ "Localization" "\0"
  /*  7124 */ "Location" "\0"
  /*  7133 */ "Lock" "\0"
  /*  7138 */ "LockManager" "\0"
  /*  7150 */ "MIDIAccess" "\0"
  /*  7161 */ "MIDIConnectionEvent" "\0"
  /*  7181 */ "MIDIInput" "\0"
  /*  7191 */ "MIDIInputMap" "\0"
  /*  7204 */ "MIDIMessageEvent" "\0"
  /*  7221 */ "MIDIOutput" "\0"
  /*  7232 */ "MIDIOutputMap" "\0"
  /*  7246 */ "MIDIPort" "\0"
  /*  7255 */ "MOZ_debug" "\0"
  /*  7265 */ "MatchGlob" "\0"
  /*  7275 */ "MatchPattern" "\0"
  /*  7288 */ "MatchPatternSet" "\0"
  /*  7304 */ "MathMLElement" "\0"
  /*  7318 */ "MediaCapabilities" "\0"
  /*  7336 */ "MediaCapabilitiesInfo" "\0"
  /*  7358 */ "MediaControlService" "\0"
  /*  7378 */ "MediaController" "\0"
  /*  7394 */ "MediaDeviceInfo" "\0"
  /*  7410 */ "MediaDevices" "\0"
  /*  7423 */ "MediaElementAudioSourceNode" "\0"
  /*  7451 */ "MediaEncryptedEvent" "\0"
  /*  7471 */ "MediaError" "\0"
  /*  7482 */ "MediaKeyError" "\0"
  /*  7496 */ "MediaKeyMessageEvent" "\0"
  /*  7517 */ "MediaKeySession" "\0"
  /*  7533 */ "MediaKeyStatusMap" "\0"
  /*  7551 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7578 */ "MediaKeySystemAccess" "\0"
  /*  7599 */ "MediaKeys" "\0"
  /*  7609 */ "MediaList" "\0"
  /*  7619 */ "MediaMetadata" "\0"
  /*  7633 */ "MediaQueryList" "\0"
  /*  7648 */ "MediaQueryListEvent" "\0"
  /*  7668 */ "MediaRecorder" "\0"
  /*  7682 */ "MediaRecorderErrorEvent" "\0"
  /*  7706 */ "MediaSession" "\0"
  /*  7719 */ "MediaSource" "\0"
  /*  7731 */ "MediaStream" "\0"
  /*  7743 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7775 */ "MediaStreamAudioSourceNode" "\0"
  /*  7802 */ "MediaStreamError" "\0"
  /*  7819 */ "MediaStreamEvent" "\0"
  /*  7836 */ "MediaStreamTrack" "\0"
  /*  7853 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7885 */ "MediaStreamTrackEvent" "\0"
  /*  7907 */ "MerchantValidationEvent" "\0"
  /*  7931 */ "MessageBroadcaster" "\0"
  /*  7950 */ "MessageChannel" "\0"
  /*  7965 */ "MessageEvent" "\0"
  /*  7978 */ "MessageListenerManager" "\0"
  /*  8001 */ "MessagePort" "\0"
  /*  8013 */ "MessageSender" "\0"
  /*  8027 */ "MimeType" "\0"
  /*  8036 */ "MimeTypeArray" "\0"
  /*  8050 */ "MouseEvent" "\0"
  /*  8061 */ "MouseScrollEvent" "\0"
  /*  8078 */ "MozCanvasPrintState" "\0"
  /*  8098 */ "MozDocumentMatcher" "\0"
  /*  8117 */ "MozDocumentObserver" "\0"
  /*  8137 */ "MozQueryInterface" "\0"
  /*  8155 */ "MozSharedMap" "\0"
  /*  8168 */ "MozSharedMap Iterator" "\0"
  /*  8190 */ "MozSharedMapChangeEvent" "\0"
  /*  8214 */ "MozStorageAsyncStatementParams" "\0"
  /*  8245 */ "MozStorageStatementParams" "\0"
  /*  8271 */ "MozStorageStatementRow" "\0"
  /*  8294 */ "MozWritableSharedMap" "\0"
  /*  8315 */ "MutationEvent" "\0"
  /*  8329 */ "MutationObserver" "\0"
  /*  8346 */ "MutationRecord" "\0"
  /*  8361 */ "NamedNodeMap" "\0"
  /*  8374 */ "NavigationPreloadManager" "\0"
  /*  8399 */ "Navigator" "\0"
  /*  8409 */ "NetworkInformation" "\0"
  /*  8428 */ "Node" "\0"
  /*  8433 */ "NodeFilter" "\0"
  /*  8444 */ "NodeIterator" "\0"
  /*  8457 */ "NodeList" "\0"
  /*  8466 */ "Notification" "\0"
  /*  8479 */ "NotificationEvent" "\0"
  /*  8497 */ "NotifyPaintEvent" "\0"
  /*  8514 */ "OES_draw_buffers_indexed" "\0"
  /*  8539 */ "OES_element_index_uint" "\0"
  /*  8562 */ "OES_fbo_render_mipmap" "\0"
  /*  8584 */ "OES_standard_derivatives" "\0"
  /*  8609 */ "OES_texture_float" "\0"
  /*  8627 */ "OES_texture_float_linear" "\0"
  /*  8652 */ "OES_texture_half_float" "\0"
  /*  8675 */ "OES_texture_half_float_linear" "\0"
  /*  8705 */ "OES_vertex_array_object" "\0"
  /*  8729 */ "OVR_multiview2" "\0"
  /*  8744 */ "OfflineAudioCompletionEvent" "\0"
  /*  8772 */ "OfflineAudioContext" "\0"
  /*  8792 */ "OffscreenCanvas" "\0"
  /*  8808 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8842 */ "OnlyForUseInConstructor" "\0"
  /*  8866 */ "Option" "\0"
  /*  8873 */ "OscillatorNode" "\0"
  /*  8888 */ "PageTransitionEvent" "\0"
  /*  8908 */ "PaintRequest" "\0"
  /*  8921 */ "PaintRequestList" "\0"
  /*  8938 */ "PaintWorkletGlobalScope" "\0"
  /*  8962 */ "PannerNode" "\0"
  /*  8973 */ "ParentProcessMessageManager" "\0"
  /*  9001 */ "Path2D" "\0"
  /*  9008 */ "PathUtils" "\0"
  /*  9018 */ "PaymentAddress" "\0"
  /*  9033 */ "PaymentMethodChangeEvent" "\0"
  /*  9058 */ "PaymentRequest" "\0"
  /*  9073 */ "PaymentRequestUpdateEvent" "\0"
  /*  9099 */ "PaymentResponse" "\0"
  /*  9115 */ "Performance" "\0"
  /*  9127 */ "PerformanceEntry" "\0"
  /*  9144 */ "PerformanceEntryEvent" "\0"
  /*  9166 */ "PerformanceEventTiming" "\0"
  /*  9189 */ "PerformanceMark" "\0"
  /*  9205 */ "PerformanceMeasure" "\0"
  /*  9224 */ "PerformanceNavigation" "\0"
  /*  9246 */ "PerformanceNavigationTiming" "\0"
  /*  9274 */ "PerformanceObserver" "\0"
  /*  9294 */ "PerformanceObserverEntryList" "\0"
  /*  9323 */ "PerformancePaintTiming" "\0"
  /*  9346 */ "PerformanceResourceTiming" "\0"
  /*  9372 */ "PerformanceServerTiming" "\0"
  /*  9396 */ "PerformanceTiming" "\0"
  /*  9414 */ "PeriodicWave" "\0"
  /*  9427 */ "PermissionStatus" "\0"
  /*  9444 */ "Permissions" "\0"
  /*  9456 */ "PlacesBookmark" "\0"
  /*  9471 */ "PlacesBookmarkAddition" "\0"
  /*  9494 */ "PlacesBookmarkChanged" "\0"
  /*  9516 */ "PlacesBookmarkGuid" "\0"
  /*  9535 */ "PlacesBookmarkKeyword" "\0"
  /*  9557 */ "PlacesBookmarkMoved" "\0"
  /*  9577 */ "PlacesBookmarkRemoved" "\0"
  /*  9599 */ "PlacesBookmarkTags" "\0"
  /*  9618 */ "PlacesBookmarkTime" "\0"
  /*  9637 */ "PlacesBookmarkTitle" "\0"
  /*  9657 */ "PlacesBookmarkUrl" "\0"
  /*  9675 */ "PlacesEvent" "\0"
  /*  9687 */ "PlacesFavicon" "\0"
  /*  9701 */ "PlacesHistoryCleared" "\0"
  /*  9722 */ "PlacesObservers" "\0"
  /*  9738 */ "PlacesPurgeCaches" "\0"
  /*  9756 */ "PlacesRanking" "\0"
  /*  9770 */ "PlacesVisit" "\0"
  /*  9782 */ "PlacesVisitRemoved" "\0"
  /*  9801 */ "PlacesVisitTitle" "\0"
  /*  9818 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9844 */ "Plugin" "\0"
  /*  9851 */ "PluginArray" "\0"
  /*  9863 */ "PluginCrashedEvent" "\0"
  /*  9882 */ "PointerEvent" "\0"
  /*  9895 */ "PopStateEvent" "\0"
  /*  9909 */ "PopupBlockedEvent" "\0"
  /*  9927 */ "PopupPositionedEvent" "\0"
  /*  9948 */ "PositionStateEvent" "\0"
  /*  9967 */ "PrecompiledScript" "\0"
  /*  9985 */ "ProcessMessageManager" "\0"
  /* 10007 */ "ProcessingInstruction" "\0"
  /* 10029 */ "ProgressEvent" "\0"
  /* 10043 */ "PromiseDebugging" "\0"
  /* 10060 */ "PromiseNativeHandler" "\0"
  /* 10081 */ "PromiseRejectionEvent" "\0"
  /* 10103 */ "PublicKeyCredential" "\0"
  /* 10123 */ "PushEvent" "\0"
  /* 10133 */ "PushManager" "\0"
  /* 10145 */ "PushManagerImpl" "\0"
  /* 10161 */ "PushMessageData" "\0"
  /* 10177 */ "PushSubscription" "\0"
  /* 10194 */ "PushSubscriptionOptions" "\0"
  /* 10218 */ "RadioNodeList" "\0"
  /* 10232 */ "Range" "\0"
  /* 10238 */ "ReadableByteStreamController" "\0"
  /* 10267 */ "ReadableStream" "\0"
  /* 10282 */ "ReadableStream AsyncIterator" "\0"
  /* 10311 */ "ReadableStreamBYOBReader" "\0"
  /* 10336 */ "ReadableStreamBYOBRequest" "\0"
  /* 10362 */ "ReadableStreamDefaultController" "\0"
  /* 10394 */ "ReadableStreamDefaultReader" "\0"
  /* 10422 */ "Report" "\0"
  /* 10429 */ "ReportBody" "\0"
  /* 10440 */ "ReportingObserver" "\0"
  /* 10458 */ "Request" "\0"
  /* 10466 */ "ResizeObserver" "\0"
  /* 10481 */ "ResizeObserverEntry" "\0"
  /* 10501 */ "ResizeObserverSize" "\0"
  /* 10520 */ "Response" "\0"
  /* 10529 */ "SVGAElement" "\0"
  /* 10541 */ "SVGAngle" "\0"
  /* 10550 */ "SVGAnimateElement" "\0"
  /* 10568 */ "SVGAnimateMotionElement" "\0"
  /* 10592 */ "SVGAnimateTransformElement" "\0"
  /* 10619 */ "SVGAnimatedAngle" "\0"
  /* 10636 */ "SVGAnimatedBoolean" "\0"
  /* 10655 */ "SVGAnimatedEnumeration" "\0"
  /* 10678 */ "SVGAnimatedInteger" "\0"
  /* 10697 */ "SVGAnimatedLength" "\0"
  /* 10715 */ "SVGAnimatedLengthList" "\0"
  /* 10737 */ "SVGAnimatedNumber" "\0"
  /* 10755 */ "SVGAnimatedNumberList" "\0"
  /* 10777 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 10808 */ "SVGAnimatedRect" "\0"
  /* 10824 */ "SVGAnimatedString" "\0"
  /* 10842 */ "SVGAnimatedTransformList" "\0"
  /* 10867 */ "SVGAnimationElement" "\0"
  /* 10887 */ "SVGCircleElement" "\0"
  /* 10904 */ "SVGClipPathElement" "\0"
  /* 10923 */ "SVGComponentTransferFunctionElement" "\0"
  /* 10959 */ "SVGDefsElement" "\0"
  /* 10974 */ "SVGDescElement" "\0"
  /* 10989 */ "SVGElement" "\0"
  /* 11000 */ "SVGEllipseElement" "\0"
  /* 11018 */ "SVGFEBlendElement" "\0"
  /* 11036 */ "SVGFEColorMatrixElement" "\0"
  /* 11060 */ "SVGFEComponentTransferElement" "\0"
  /* 11090 */ "SVGFECompositeElement" "\0"
  /* 11112 */ "SVGFEConvolveMatrixElement" "\0"
  /* 11139 */ "SVGFEDiffuseLightingElement" "\0"
  /* 11167 */ "SVGFEDisplacementMapElement" "\0"
  /* 11195 */ "SVGFEDistantLightElement" "\0"
  /* 11220 */ "SVGFEDropShadowElement" "\0"
  /* 11243 */ "SVGFEFloodElement" "\0"
  /* 11261 */ "SVGFEFuncAElement" "\0"
  /* 11279 */ "SVGFEFuncBElement" "\0"
  /* 11297 */ "SVGFEFuncGElement" "\0"
  /* 11315 */ "SVGFEFuncRElement" "\0"
  /* 11333 */ "SVGFEGaussianBlurElement" "\0"
  /* 11358 */ "SVGFEImageElement" "\0"
  /* 11376 */ "SVGFEMergeElement" "\0"
  /* 11394 */ "SVGFEMergeNodeElement" "\0"
  /* 11416 */ "SVGFEMorphologyElement" "\0"
  /* 11439 */ "SVGFEOffsetElement" "\0"
  /* 11458 */ "SVGFEPointLightElement" "\0"
  /* 11481 */ "SVGFESpecularLightingElement" "\0"
  /* 11510 */ "SVGFESpotLightElement" "\0"
  /* 11532 */ "SVGFETileElement" "\0"
  /* 11549 */ "SVGFETurbulenceElement" "\0"
  /* 11572 */ "SVGFilterElement" "\0"
  /* 11589 */ "SVGForeignObjectElement" "\0"
  /* 11613 */ "SVGGElement" "\0"
  /* 11625 */ "SVGGeometryElement" "\0"
  /* 11644 */ "SVGGradientElement" "\0"
  /* 11663 */ "SVGGraphicsElement" "\0"
  /* 11682 */ "SVGImageElement" "\0"
  /* 11698 */ "SVGLength" "\0"
  /* 11708 */ "SVGLengthList" "\0"
  /* 11722 */ "SVGLineElement" "\0"
  /* 11737 */ "SVGLinearGradientElement" "\0"
  /* 11762 */ "SVGMPathElement" "\0"
  /* 11778 */ "SVGMarkerElement" "\0"
  /* 11795 */ "SVGMaskElement" "\0"
  /* 11810 */ "SVGMatrix" "\0"
  /* 11820 */ "SVGMetadataElement" "\0"
  /* 11839 */ "SVGNumber" "\0"
  /* 11849 */ "SVGNumberList" "\0"
  /* 11863 */ "SVGPathElement" "\0"
  /* 11878 */ "SVGPathSeg" "\0"
  /* 11889 */ "SVGPathSegArcAbs" "\0"
  /* 11906 */ "SVGPathSegArcRel" "\0"
  /* 11923 */ "SVGPathSegClosePath" "\0"
  /* 11943 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 11969 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 11995 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 12027 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 12059 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 12089 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 12119 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 12155 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 12191 */ "SVGPathSegLinetoAbs" "\0"
  /* 12211 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 12241 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12271 */ "SVGPathSegLinetoRel" "\0"
  /* 12291 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12319 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12347 */ "SVGPathSegList" "\0"
  /* 12362 */ "SVGPathSegMovetoAbs" "\0"
  /* 12382 */ "SVGPathSegMovetoRel" "\0"
  /* 12402 */ "SVGPatternElement" "\0"
  /* 12420 */ "SVGPoint" "\0"
  /* 12429 */ "SVGPointList" "\0"
  /* 12442 */ "SVGPolygonElement" "\0"
  /* 12460 */ "SVGPolylineElement" "\0"
  /* 12479 */ "SVGPreserveAspectRatio" "\0"
  /* 12502 */ "SVGRadialGradientElement" "\0"
  /* 12527 */ "SVGRect" "\0"
  /* 12535 */ "SVGRectElement" "\0"
  /* 12550 */ "SVGSVGElement" "\0"
  /* 12564 */ "SVGScriptElement" "\0"
  /* 12581 */ "SVGSetElement" "\0"
  /* 12595 */ "SVGStopElement" "\0"
  /* 12610 */ "SVGStringList" "\0"
  /* 12624 */ "SVGStyleElement" "\0"
  /* 12640 */ "SVGSwitchElement" "\0"
  /* 12657 */ "SVGSymbolElement" "\0"
  /* 12674 */ "SVGTSpanElement" "\0"
  /* 12690 */ "SVGTextContentElement" "\0"
  /* 12712 */ "SVGTextElement" "\0"
  /* 12727 */ "SVGTextPathElement" "\0"
  /* 12746 */ "SVGTextPositioningElement" "\0"
  /* 12772 */ "SVGTitleElement" "\0"
  /* 12788 */ "SVGTransform" "\0"
  /* 12801 */ "SVGTransformList" "\0"
  /* 12818 */ "SVGUnitTypes" "\0"
  /* 12831 */ "SVGUseElement" "\0"
  /* 12845 */ "SVGViewElement" "\0"
  /* 12860 */ "Sanitizer" "\0"
  /* 12870 */ "Scheduler" "\0"
  /* 12880 */ "Screen" "\0"
  /* 12887 */ "ScreenLuminance" "\0"
  /* 12903 */ "ScreenOrientation" "\0"
  /* 12921 */ "ScriptProcessorNode" "\0"
  /* 12941 */ "ScrollAreaEvent" "\0"
  /* 12957 */ "ScrollViewChangeEvent" "\0"
  /* 12979 */ "SecurityPolicyViolationEvent" "\0"
  /* 13008 */ "Selection" "\0"
  /* 13018 */ "ServiceWorker" "\0"
  /* 13032 */ "ServiceWorkerContainer" "\0"
  /* 13055 */ "ServiceWorkerGlobalScope" "\0"
  /* 13080 */ "ServiceWorkerRegistration" "\0"
  /* 13106 */ "SessionStoreFormData" "\0"
  /* 13127 */ "SessionStoreScrollData" "\0"
  /* 13150 */ "SessionStoreUtils" "\0"
  /* 13168 */ "ShadowRealmGlobalScope" "\0"
  /* 13191 */ "ShadowRoot" "\0"
  /* 13202 */ "SharedWorker" "\0"
  /* 13215 */ "SharedWorkerGlobalScope" "\0"
  /* 13239 */ "SimpleGestureEvent" "\0"
  /* 13258 */ "SourceBuffer" "\0"
  /* 13271 */ "SourceBufferList" "\0"
  /* 13288 */ "SpeechGrammar" "\0"
  /* 13302 */ "SpeechGrammarList" "\0"
  /* 13320 */ "SpeechRecognition" "\0"
  /* 13338 */ "SpeechRecognitionAlternative" "\0"
  /* 13367 */ "SpeechRecognitionError" "\0"
  /* 13390 */ "SpeechRecognitionEvent" "\0"
  /* 13413 */ "SpeechRecognitionResult" "\0"
  /* 13437 */ "SpeechRecognitionResultList" "\0"
  /* 13465 */ "SpeechSynthesis" "\0"
  /* 13481 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13507 */ "SpeechSynthesisEvent" "\0"
  /* 13528 */ "SpeechSynthesisUtterance" "\0"
  /* 13553 */ "SpeechSynthesisVoice" "\0"
  /* 13574 */ "StaticRange" "\0"
  /* 13586 */ "StereoPannerNode" "\0"
  /* 13603 */ "Storage" "\0"
  /* 13611 */ "StorageEvent" "\0"
  /* 13624 */ "StorageManager" "\0"
  /* 13639 */ "StreamFilter" "\0"
  /* 13652 */ "StreamFilterDataEvent" "\0"
  /* 13674 */ "StructuredCloneHolder" "\0"
  /* 13696 */ "StructuredCloneTester" "\0"
  /* 13718 */ "StyleSheet" "\0"
  /* 13729 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 13766 */ "StyleSheetList" "\0"
  /* 13781 */ "SubmitEvent" "\0"
  /* 13793 */ "SubtleCrypto" "\0"
  /* 13806 */ "SyncMessageSender" "\0"
  /* 13824 */ "SyncReadFile" "\0"
  /* 13837 */ "TCPServerSocket" "\0"
  /* 13853 */ "TCPServerSocketEvent" "\0"
  /* 13874 */ "TCPSocket" "\0"
  /* 13884 */ "TCPSocketErrorEvent" "\0"
  /* 13904 */ "TCPSocketEvent" "\0"
  /* 13919 */ "TaskController" "\0"
  /* 13934 */ "TaskPriorityChangeEvent" "\0"
  /* 13958 */ "TaskSignal" "\0"
  /* 13969 */ "TelemetryStopwatch" "\0"
  /* 13988 */ "TestAttributesOnTypes" "\0"
  /* 14010 */ "TestCEReactionsInterface" "\0"
  /* 14035 */ "TestCImplementedInterface" "\0"
  /* 14061 */ "TestCImplementedInterface2" "\0"
  /* 14088 */ "TestChildInterface" "\0"
  /* 14107 */ "TestConstructorForFuncInterface" "\0"
  /* 14139 */ "TestConstructorForPrefInterface" "\0"
  /* 14171 */ "TestConstructorForSCInterface" "\0"
  /* 14201 */ "TestCppKeywordNamedMethodsInterface" "\0"
  /* 14237 */ "TestDeprecatedInterface" "\0"
  /* 14261 */ "TestExampleInterface" "\0"
  /* 14282 */ "TestExampleProxyInterface" "\0"
  /* 14308 */ "TestExampleThrowingConstructorInterface" "\0"
  /* 14348 */ "TestExampleWorkerInterface" "\0"
  /* 14375 */ "TestFuncConstructorForDifferentFuncInterface" "\0"
  /* 14420 */ "TestFuncConstructorForInterface" "\0"
  /* 14452 */ "TestHTMLConstructorInterface" "\0"
  /* 14481 */ "TestIndexedAndNamedGetterAndSetterInterface" "\0"
  /* 14525 */ "TestIndexedAndNamedGetterInterface" "\0"
  /* 14560 */ "TestIndexedAndNamedSetterInterface" "\0"
  /* 14595 */ "TestIndexedGetterAndSetterAndNamedGetterInterface" "\0"
  /* 14645 */ "TestIndexedGetterInterface" "\0"
  /* 14672 */ "TestIndexedSetterInterface" "\0"
  /* 14699 */ "TestInterface" "\0"
  /* 14713 */ "TestInterfaceWithPromiseConstructorArg" "\0"
  /* 14752 */ "TestJSImplInterface" "\0"
  /* 14772 */ "TestJSImplInterface2" "\0"
  /* 14793 */ "TestJSImplInterface3" "\0"
  /* 14814 */ "TestJSImplInterface4" "\0"
  /* 14835 */ "TestJSImplInterface5" "\0"
  /* 14856 */ "TestJSImplInterface6" "\0"
  /* 14877 */ "TestJSImplNoInterfaceObject" "\0"
  /* 14905 */ "TestNamedDeleterInterface" "\0"
  /* 14931 */ "TestNamedDeleterWithRetvalInterface" "\0"
  /* 14967 */ "TestNamedGetterInterface" "\0"
  /* 14992 */ "TestNamedSetterInterface" "\0"
  /* 15017 */ "TestNamespace" "\0"
  /* 15031 */ "TestNonWrapperCacheInterface" "\0"
  /* 15060 */ "TestParentInterface" "\0"
  /* 15080 */ "TestPrefChromeOnlySCFuncConstructorForInterface" "\0"
  /* 15128 */ "TestPrefConstructorForDifferentPrefInterface" "\0"
  /* 15173 */ "TestPrefConstructorForInterface" "\0"
  /* 15205 */ "TestProtoObjectHackedNamespace" "\0"
  /* 15236 */ "TestRenamedInterface" "\0"
  /* 15257 */ "TestRenamedNamespace" "\0"
  /* 15278 */ "TestSCConstructorForInterface" "\0"
  /* 15308 */ "TestSecureContextInterface" "\0"
  /* 15335 */ "TestThrowingConstructorInterface" "\0"
  /* 15368 */ "TestUtils" "\0"
  /* 15378 */ "TestWorkerExposedInterface" "\0"
  /* 15405 */ "TestingDeprecatedInterface" "\0"
  /* 15432 */ "Text" "\0"
  /* 15437 */ "TextClause" "\0"
  /* 15448 */ "TextDecoder" "\0"
  /* 15460 */ "TextDecoderStream" "\0"
  /* 15478 */ "TextEncoder" "\0"
  /* 15490 */ "TextEncoderStream" "\0"
  /* 15508 */ "TextMetrics" "\0"
  /* 15520 */ "TextTrack" "\0"
  /* 15530 */ "TextTrackCue" "\0"
  /* 15543 */ "TextTrackCueList" "\0"
  /* 15560 */ "TextTrackList" "\0"
  /* 15574 */ "TimeEvent" "\0"
  /* 15584 */ "TimeRanges" "\0"
  /* 15595 */ "ToggleEvent" "\0"
  /* 15607 */ "Touch" "\0"
  /* 15613 */ "TouchEvent" "\0"
  /* 15624 */ "TouchList" "\0"
  /* 15634 */ "TrackEvent" "\0"
  /* 15645 */ "TransformStream" "\0"
  /* 15661 */ "TransformStreamDefaultController" "\0"
  /* 15694 */ "TransitionEvent" "\0"
  /* 15710 */ "TreeColumn" "\0"
  /* 15721 */ "TreeColumns" "\0"
  /* 15733 */ "TreeContentView" "\0"
  /* 15749 */ "TreeWalker" "\0"
  /* 15760 */ "UDPMessageEvent" "\0"
  /* 15776 */ "UDPSocket" "\0"
  /* 15786 */ "UIEvent" "\0"
  /* 15794 */ "URL" "\0"
  /* 15798 */ "URLSearchParams" "\0"
  /* 15814 */ "URLSearchParams Iterator" "\0"
  /* 15839 */ "UniFFIPointer" "\0"
  /* 15853 */ "UniFFIScaffolding" "\0"
  /* 15871 */ "UserInteraction" "\0"
  /* 15887 */ "UserProximityEvent" "\0"
  /* 15906 */ "VRDisplay" "\0"
  /* 15916 */ "VRDisplayCapabilities" "\0"
  /* 15938 */ "VRDisplayEvent" "\0"
  /* 15953 */ "VREyeParameters" "\0"
  /* 15969 */ "VRFieldOfView" "\0"
  /* 15983 */ "VRFrameData" "\0"
  /* 15995 */ "VRMockController" "\0"
  /* 16012 */ "VRMockDisplay" "\0"
  /* 16026 */ "VRPose" "\0"
  /* 16033 */ "VRServiceTest" "\0"
  /* 16047 */ "VRStageParameters" "\0"
  /* 16065 */ "VTTCue" "\0"
  /* 16072 */ "VTTRegion" "\0"
  /* 16082 */ "ValidityState" "\0"
  /* 16096 */ "VideoColorSpace" "\0"
  /* 16112 */ "VideoFrame" "\0"
  /* 16123 */ "VideoPlaybackQuality" "\0"
  /* 16144 */ "VideoTrack" "\0"
  /* 16155 */ "VideoTrackList" "\0"
  /* 16170 */ "VisualViewport" "\0"
  /* 16185 */ "WEBGL_color_buffer_float" "\0"
  /* 16210 */ "WEBGL_compressed_texture_astc" "\0"
  /* 16240 */ "WEBGL_compressed_texture_etc" "\0"
  /* 16269 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 16299 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 16330 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 16360 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 16395 */ "WEBGL_debug_renderer_info" "\0"
  /* 16421 */ "WEBGL_debug_shaders" "\0"
  /* 16441 */ "WEBGL_depth_texture" "\0"
  /* 16461 */ "WEBGL_draw_buffers" "\0"
  /* 16480 */ "WEBGL_explicit_present" "\0"
  /* 16503 */ "WEBGL_lose_context" "\0"
  /* 16522 */ "WEBGL_provoking_vertex" "\0"
  /* 16545 */ "WaveShaperNode" "\0"
  /* 16560 */ "WebExtensionContentScript" "\0"
  /* 16586 */ "WebExtensionPolicy" "\0"
  /* 16605 */ "WebGL2RenderingContext" "\0"
  /* 16628 */ "WebGLActiveInfo" "\0"
  /* 16644 */ "WebGLBuffer" "\0"
  /* 16656 */ "WebGLContextEvent" "\0"
  /* 16674 */ "WebGLFramebuffer" "\0"
  /* 16691 */ "WebGLProgram" "\0"
  /* 16704 */ "WebGLQuery" "\0"
  /* 16715 */ "WebGLRenderbuffer" "\0"
  /* 16733 */ "WebGLRenderingContext" "\0"
  /* 16755 */ "WebGLSampler" "\0"
  /* 16768 */ "WebGLShader" "\0"
  /* 16780 */ "WebGLShaderPrecisionFormat" "\0"
  /* 16807 */ "WebGLSync" "\0"
  /* 16817 */ "WebGLTexture" "\0"
  /* 16830 */ "WebGLTransformFeedback" "\0"
  /* 16853 */ "WebGLUniformLocation" "\0"
  /* 16874 */ "WebGLVertexArrayObject" "\0"
  /* 16897 */ "WebKitCSSMatrix" "\0"
  /* 16913 */ "WebSocket" "\0"
  /* 16923 */ "WebTransport" "\0"
  /* 16936 */ "WebTransportBidirectionalStream" "\0"
  /* 16968 */ "WebTransportDatagramDuplexStream" "\0"
  /* 17001 */ "WebTransportError" "\0"
  /* 17019 */ "WebTransportReceiveStream" "\0"
  /* 17045 */ "WebTransportSendStream" "\0"
  /* 17068 */ "WheelEvent" "\0"
  /* 17079 */ "Window" "\0"
  /* 17086 */ "WindowClient" "\0"
  /* 17099 */ "WindowContext" "\0"
  /* 17113 */ "WindowGlobalChild" "\0"
  /* 17131 */ "WindowGlobalParent" "\0"
  /* 17150 */ "WindowRoot" "\0"
  /* 17161 */ "Worker" "\0"
  /* 17168 */ "WorkerDebuggerGlobalScope" "\0"
  /* 17194 */ "WorkerGlobalScope" "\0"
  /* 17212 */ "WorkerLocation" "\0"
  /* 17227 */ "WorkerNavigator" "\0"
  /* 17243 */ "WorkerTestUtils" "\0"
  /* 17259 */ "Worklet" "\0"
  /* 17267 */ "WorkletGlobalScope" "\0"
  /* 17286 */ "WritableStream" "\0"
  /* 17301 */ "WritableStreamDefaultController" "\0"
  /* 17333 */ "WritableStreamDefaultWriter" "\0"
  /* 17361 */ "XMLDocument" "\0"
  /* 17373 */ "XMLHttpRequest" "\0"
  /* 17388 */ "XMLHttpRequestEventTarget" "\0"
  /* 17414 */ "XMLHttpRequestUpload" "\0"
  /* 17435 */ "XMLSerializer" "\0"
  /* 17449 */ "XPathEvaluator" "\0"
  /* 17464 */ "XPathExpression" "\0"
  /* 17480 */ "XPathResult" "\0"
  /* 17492 */ "XRBoundedReferenceSpace" "\0"
  /* 17516 */ "XRFrame" "\0"
  /* 17524 */ "XRInputSource" "\0"
  /* 17538 */ "XRInputSourceArray" "\0"
  /* 17557 */ "XRInputSourceEvent" "\0"
  /* 17576 */ "XRInputSourcesChangeEvent" "\0"
  /* 17602 */ "XRPose" "\0"
  /* 17609 */ "XRReferenceSpace" "\0"
  /* 17626 */ "XRReferenceSpaceEvent" "\0"
  /* 17648 */ "XRRenderState" "\0"
  /* 17662 */ "XRRigidTransform" "\0"
  /* 17679 */ "XRSession" "\0"
  /* 17689 */ "XRSessionEvent" "\0"
  /* 17704 */ "XRSpace" "\0"
  /* 17712 */ "XRSystem" "\0"
  /* 17721 */ "XRView" "\0"
  /* 17728 */ "XRViewerPose" "\0"
  /* 17741 */ "XRViewport" "\0"
  /* 17752 */ "XRWebGLLayer" "\0"
  /* 17765 */ "XSLTProcessor" "\0"
  /* 17779 */ "XULCommandEvent" "\0"
  /* 17795 */ "XULElement" "\0"
  /* 17806 */ "XULFrameElement" "\0"
  /* 17822 */ "XULMenuElement" "\0"
  /* 17837 */ "XULPopupElement" "\0"
  /* 17853 */ "XULResizerElement" "\0"
  /* 17871 */ "XULTextElement" "\0"
  /* 17886 */ "XULTreeElement" "\0"
  /* 17901 */ "console" "\0"
  /* 17909 */ "webkitSpeechGrammar" "\0"
  /* 17929 */ "webkitSpeechGrammarList" "\0"
  /* 17953 */ "webkitSpeechRecognition" "\0"
  /* 17977 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

